unit Unit1;

{$mode objfpc}{$H+}

interface

uses
    Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Spin,
    mscoreengine, msScriptEditor, uPSComponent, PythonEngine,
    Lcl.PythonGUIInputOutput, DateUtils, Variants;

type

    { TForm1 }

    TForm1 = class(TForm)
        btnMagic: TButton;
        btnPascal: TButton;
        btnPython: TButton;
        Label2: TLabel;
        Memo3: TMemo;
        Memo2: TMemo;
        mscrPascalScript1: TmscrPascalScript;
        mscrScriptTerminal1: TmscrScriptTerminal;
        PSScript1: TPSScript;
        nTimes: TSpinEdit;
        count: TSpinEdit;
        PythonEngine1: TPythonEngine;
        PythonGUIInputOutput1: TPythonGUIInputOutput;
        procedure btnMagicClick(Sender: TObject);
        procedure btnPascalClick(Sender: TObject);
        procedure btnPythonClick(Sender: TObject);
        procedure FormCreate(Sender: TObject);
        procedure PSScript1Compile(Sender: TPSScript);
    private

    public
        procedure TestMagic;
        procedure TestPascal;
        procedure TestPython;
    end;

var
    Form1: TForm1;

implementation

procedure MRegresa(v : variant);
var
    s: String;
begin
    s := v ;
    form1.Memo2.Lines.Clear;
    form1.Memo2.Lines.Add(s) ;
end;

{$R *.frm}

{ TForm1 }
procedure TForm1.FormCreate(Sender: TObject);
begin
  VarMSCR_ConcoleOut:=mscrScriptTerminal1;
end;

procedure TForm1.PSScript1Compile(Sender: TPSScript);
begin
    Sender.AddFunction(@MRegresa, 'procedure Regresa(const v:variant)');
end;


procedure TForm1.btnMagicClick(Sender: TObject);
var
    i : Integer ;
    t1, t2 : TTime ;
    f : Double ;
begin
    t1 := Time() ;
    for i:= 1 to nTimes.Value do begin
        TestMagic ;
        Application.ProcessMessages;
        count.Value:=i;
    end;
    t2 := Time ;
    f := SecondsBetween(t2, t1) ;
    ShowMessage( 'Finish in ' + FloatToStr(f) + ' Seconds' ) ;
end;

procedure TForm1.btnPascalClick(Sender: TObject);
var
    i : Integer ;
    t1, t2 : TTime ;
    f : Double ;
begin
    t1 := Time() ;
    for i:= 1 to nTimes.value do begin
        TestPascal ;
        Application.ProcessMessages;
        count.Value:=i;
    end;
    t2 := Time ;
    f := SecondsBetween(t2, t1) ;
    ShowMessage( 'Finish in ' + FloatToStr(f) + ' Seconds' ) ;
end;

procedure TForm1.btnPythonClick(Sender: TObject);
var
    i : Integer ;
    t1, t2 : TTime ;
    f : Double ;
begin
    t1 := Time() ;
    for i:= 1 to nTimes.value do begin
        TestPython ;
        Application.ProcessMessages;
        count.Value:=i;
    end;
    t2 := Time ;
    f := SecondsBetween(t2, t1) ;
    ShowMessage( 'Finish in ' + FloatToStr(f) + ' Seconds' ) ;
end;

// COMPILE PROCEDURES
procedure TForm1.TestMagic;
begin
    mscrScriptTerminal1.Clear;
    mscrPascalScript1.Parent := MSCR_GlobalScripter;
    if not mscrPascalScript1.Compile then;
    try
      mscrPascalScript1.Execute;
    except
    end;
end;

procedure TForm1.TestPascal;
begin
    if PSScript1.compile then
        try
            PSScript1.execute ;
        except
        end;
end;

procedure TForm1.TestPython;
begin
    PythonEngine1.InitScript.Clear;
    PythonEngine1.InitScript.Add('print( 16/100 )' );
    memo3.Lines.Clear;
    try
        PythonEngine1.ExecStrings(PythonEngine1.InitScript);
    except
    end;
end;

end.

